//Управление от пультов RC-5 и NEC, журнал РХ-4/2013
#include <IRremote.h> //Библиотека ИК-управления
int RECV_PIN = 11; //Фотомодуль подключается к порту D11
IRrecv irrecv(RECV_PIN); //Стандартное определение
decode_results results;  //Стандартное определение
//========Функция декодирования протокола ДУ============
void pdu(decode_results *results)
{ unsigned long r = results->value; //Результат
  int number=0; int on = 0; //Вспомогательные переменные
  
  if (results->decode_type==NEC) Serial.print("NEC: ");
  if (results->decode_type==RC5) Serial.print("RC5: ");   
  Serial.println(r, HEX); //Вывод надписей в терминал
  if ((r==0xFF30CF)||(r==0x10)||(r==0x810)) number=1;
  if ((r==0xFF18E7)||(r==0x11)||(r==0x811)) number=2;
  if ((r==0xFF7A85)||(r==0x0D)||(r==0x80D)) number=3;
  if (number) //Если были нажаты требуемые кнопки
  { for (int b=0; b < (number * 2); b++) //Мигание
    { on = !on; //Поочередная смена "ВКЛ-ВЫКЛ"
      digitalWrite(13, on ? HIGH : LOW); //Порт D13
      delay(200); //Задержка 200 мс для мигания "L"
    }
  } //Если нажаты "не те" кнопки, то пропуск блока "if"
}
//================Начальные установки===================
void setup() //Блок инициализации
{ pinMode(13, OUTPUT); //Настройка порта D13 на выход
  Serial.begin(9600); //Настройка UART 9600 бод
  irrecv.enableIRIn(); //Старт декодирования
}
//================Основная программа====================
void loop() //Выполнение в бесконечном цикле
{ if (irrecv.decode(&results)) //Успешное декодирование
  { pdu(&results); //Вызов функции обработки
    irrecv.resume(); //Ожидание следующей посылки
  }
} //Arduino-1.0.5, длина кода 9352 байта